import numpy as np
from edgeiq._constants import SupportedPurposes as SupportedPurposes
from edgeiq._utils import gen_logger as gen_logger
from edgeiq.base_service import BaseService as BaseService
from edgeiq.model_config import ModelConfig as ModelConfig
from edgeiq.pose_estimation_pose import Pose as Pose
from edgeiq.processing import PoseEstimationProcessor as PoseEstimationProcessor
from edgeiq.tools import to_json_serializable as to_json_serializable
from edgeiq.tools.image_manipulation import pad_to_aspect_ratio as pad_to_aspect_ratio

class HumanPoseResult:
    def __init__(self, poses: list[Pose], duration: float, input_dimension: tuple[int, int], image: np.ndarray, **kwargs) -> None: ...
    def __eq__(self, other): ...
    @property
    def duration(self) -> float: ...
    @property
    def poses(self) -> list[Pose]: ...
    @property
    def image(self) -> np.ndarray: ...
    def draw_poses_background(self, color: tuple[int, int, int]) -> np.ndarray: ...
    def draw_poses(self, image: np.ndarray | None = None) -> np.ndarray: ...
    def draw_aliens(self) -> np.ndarray: ...

class PoseEstimation(BaseService[PoseEstimationProcessor, HumanPoseResult]):
    def __init__(self, model_id: str, model_config: ModelConfig | None = None) -> None: ...
    def estimate(self, image: np.ndarray) -> HumanPoseResult: ...
